"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = _default;

var tslib_1 = _interopRequireWildcard(require("tslib"));

var _fs = _interopRequireDefault(require("fs"));

var _path = _interopRequireDefault(require("path"));

var _tsImportPlugin = _interopRequireDefault(require("ts-import-plugin"));

var _tsTransformGraphqlTag = require("ts-transform-graphql-tag");

function _default(context, next) {
  return tslib_1.__awaiter(this, void 0, void 0, function () {
    var cwd, ENV, typescriptConfigPath, options, tsconfigPath, importPluginOptions, useGQL;
    return tslib_1.__generator(this, function (_a) {
      cwd = context.cwd, ENV = context.ENV;
      typescriptConfigPath = _path["default"].join(__dirname, '../tsconfig.json');
      options = require(typescriptConfigPath);
      tsconfigPath = _path["default"].resolve(cwd, 'tsconfig.json');

      if (_fs["default"].existsSync(tsconfigPath)) {
        options = require(tsconfigPath);
      }

      options.compilerOptions.sourceMap = ENV.isDevelopment;
      options.compilerOptions.module = 'ESNEXT';
      context.typescriptOptions = context.tsOptions = {
        transpileOnly: true,
        happyPackMode: true,
        experimentalWatchApi: true,
        compilerOptions: options.compilerOptions
      };
      next();
      importPluginOptions = context.importPluginOptions, useGQL = context.useGQL;

      context.tsOptions.getCustomTransformers = function () {
        var before = [];

        if (importPluginOptions) {
          before.push.apply(before, importPluginOptions.map(function (o) {
            return (0, _tsImportPlugin["default"])(o);
          }));
        }

        if (useGQL) {}

        before.push((0, _tsTransformGraphqlTag.getTransformer)());
        return {
          before: before
        };
      };

      return [2];
    });
  });
}